//
// Created by zx on 23-8-4.
//

#ifndef FAST_LIO_SAM_KEYFRAMESMANAGER_H
#define FAST_LIO_SAM_KEYFRAMESMANAGER_H
#include "common_lib.h"
#include "preprocess.h"
class keyFrame{
public:
    keyFrame(PointCloudXYZI::Ptr cloud);
    keyFrame(PointTypePose pose,PointCloudXYZI::Ptr cloud);
    ~keyFrame();
    void ResetPose(PointTypePose pose);
    PointTypePose Pose(){return pose_;}
    PointCloudXYZI::Ptr cloud(){return cloud_;}
    PointCloudXYZI::Ptr world_cloud();
protected:
    PointTypePose pose_;
    PointCloudXYZI::Ptr cloud_;
    PointCloudXYZI::Ptr cloud_world_;
    bool pose_changed_;
};

class keyFramesManager {
public:
    keyFramesManager();
    ~keyFramesManager();

    pcl::PointCloud<PointTypePose>::Ptr GetPoses();

    std::vector<keyFrame> frames_;

};

#endif //FAST_LIO_SAM_KEYFRAMESMANAGER_H
